/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.35 Revision 1.423
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.35 2003/06/22 05:44:04 drobbins Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.423 2013/06/21 23:56:06 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
14 7# base-system@gentoo.org
15DEPEND="$DEPEND !bootstrap? ( sys-devel/patch )" 8# @BLURB: many extra (but common) functions that are used in ebuilds
16 9# @DESCRIPTION:
17DESCRIPTION="Based on the ${ECLASS} eclass" 10# The eutils eclass contains a suite of functions that complement
18 11# the ones that ebuild.sh already contain. The idea is that the functions
19# This function generate linker scripts in /usr/lib for dynamic 12# are not required in all ebuilds but enough utilize them to have a common
20# libs in /lib. This is to fix linking problems when you have 13# home rather than having multiple ebuilds implementing the same thing.
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26# 14#
27# To use, simply call: 15# Due to the nature of this eclass, some functions may have maintainers
28# 16# different from the overall eclass!
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 17
39 # Just make sure it exists 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
40 dodir /usr/lib 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
41 20
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 21inherit multilib toolchain-funcs user
43/* GNU ld script
44 Because Gentoo have critical dynamic libraries
45 in /lib, and the static versions in /usr/lib, we
46 need to have a "fake" dynamic lib in /usr/lib,
47 otherwise we run into linking problems.
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52 22
53 dosed "s:libxxx:$1:" /usr/lib/$1 23if has "${EAPI:-0}" 0 1 2; then
54 24
25# @FUNCTION: epause
26# @USAGE: [seconds]
27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
32epause() {
33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34}
35
36# @FUNCTION: ebeep
37# @USAGE: [number of beeps]
38# @DESCRIPTION:
39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
43ebeep() {
44 local n
45 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47 echo -ne "\a"
48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49 echo -ne "\a"
50 sleep 1
51 done
52 fi
53}
54
55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: evar_push
150# @USAGE: <variable to save> [more vars to save]
151# @DESCRIPTION:
152# This let's you temporarily modify a variable and then restore it (including
153# set vs unset semantics). Arrays are not supported at this time.
154#
155# This is meant for variables where using `local` does not work (such as
156# exported variables, or only temporarily changing things in a func).
157#
158# For example:
159# @CODE
160# evar_push LC_ALL
161# export LC_ALL=C
162# ... do some stuff that needs LC_ALL=C set ...
163# evar_pop
164#
165# # You can also save/restore more than one var at a time
166# evar_push BUTTERFLY IN THE SKY
167# ... do stuff with the vars ...
168# evar_pop # This restores just one var, SKY
169# ... do more stuff ...
170# evar_pop 3 # This pops the remaining 3 vars
171# @CODE
172evar_push() {
173 local var val
174 for var ; do
175 [[ ${!var+set} == "set" ]] \
176 && val=${!var} \
177 || val="${___ECLASS_ONCE_EUTILS}"
178 estack_push evar "${var}" "${val}"
179 done
180}
181
182# @FUNCTION: evar_push_set
183# @USAGE: <variable to save> [new value to store]
184# @DESCRIPTION:
185# This is a handy shortcut to save and temporarily set a variable. If a value
186# is not specified, the var will be unset.
187evar_push_set() {
188 local var=$1
189 evar_push ${var}
190 case $# in
191 1) unset ${var} ;;
192 2) printf -v "${var}" '%s' "$2" ;;
193 *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194 esac
195}
196
197# @FUNCTION: evar_pop
198# @USAGE: [number of vars to restore]
199# @DESCRIPTION:
200# Restore the variables to the state saved with the corresponding
201# evar_push call. See that function for more details.
202evar_pop() {
203 local cnt=${1:-bad}
204 case $# in
205 0) cnt=1 ;;
206 1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207 *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208 esac
209
210 local var val
211 while (( cnt-- )) ; do
212 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 [[ ${val} == "${___ECLASS_ONCE_EUTILS}" ]] \
215 && unset ${var} \
216 || printf -v "${var}" '%s' "${val}"
217 done
218}
219
220# @FUNCTION: eshopts_push
221# @USAGE: [options to `set` or `shopt`]
222# @DESCRIPTION:
223# Often times code will want to enable a shell option to change code behavior.
224# Since changing shell options can easily break other pieces of code (which
225# assume the default state), eshopts_push is used to (1) push the current shell
226# options onto a stack and (2) pass the specified arguments to set.
227#
228# If the first argument is '-s' or '-u', we assume you want to call `shopt`
229# rather than `set` as there are some options only available via that.
230#
231# A common example is to disable shell globbing so that special meaning/care
232# may be used with variables/arguments to custom functions. That would be:
233# @CODE
234# eshopts_push -s noglob
235# for x in ${foo} ; do
236# if ...some check... ; then
237# eshopts_pop
238# return 0
239# fi
240# done
241# eshopts_pop
242# @CODE
243eshopts_push() {
244 if [[ $1 == -[su] ]] ; then
245 estack_push eshopts "$(shopt -p)"
246 [[ $# -eq 0 ]] && return 0
247 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248 else
249 estack_push eshopts $-
250 [[ $# -eq 0 ]] && return 0
251 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252 fi
253}
254
255# @FUNCTION: eshopts_pop
256# @USAGE:
257# @DESCRIPTION:
258# Restore the shell options to the state saved with the corresponding
259# eshopts_push call. See that function for more details.
260eshopts_pop() {
261 local s
262 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263 if [[ ${s} == "shopt -"* ]] ; then
264 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265 else
266 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268 fi
269}
270
271# @FUNCTION: eumask_push
272# @USAGE: <new umask>
273# @DESCRIPTION:
274# Set the umask to the new value specified while saving the previous
275# value onto a stack. Useful for temporarily changing the umask.
276eumask_push() {
277 estack_push eumask "$(umask)"
278 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279}
280
281# @FUNCTION: eumask_pop
282# @USAGE:
283# @DESCRIPTION:
284# Restore the previous umask state.
285eumask_pop() {
286 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 local s
288 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290}
291
292# @FUNCTION: isdigit
293# @USAGE: <number> [more numbers]
294# @DESCRIPTION:
295# Return true if all arguments are numbers.
296isdigit() {
297 local d
298 for d ; do
299 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300 done
55 return 0 301 return 0
56} 302}
57 303
58# Simple function to draw a line consisting of '=' the same length as $* 304# @VARIABLE: EPATCH_SOURCE
59# 305# @DESCRIPTION:
60# <azarah@gentoo.org> (11 Nov 2002) 306# Default directory to search for patches.
61#
62draw_line() {
63 local i=0
64 local str_length=""
65
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "="
79
80 i=$((i + 1))
81 done
82
83 echo
84
85 return 0
86}
87
88# Default directory where patches are located
89EPATCH_SOURCE="${WORKDIR}/patch" 307EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 308# @VARIABLE: EPATCH_SUFFIX
309# @DESCRIPTION:
310# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 311EPATCH_SUFFIX="patch.bz2"
92# Default options for patch 312# @VARIABLE: EPATCH_OPTS
313# @DESCRIPTION:
314# Options to pass to patch. Meant for ebuild/package-specific tweaking
315# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316# for single patch tweaking, you can also pass flags directly to epatch.
93EPATCH_OPTS="" 317EPATCH_OPTS=""
318# @VARIABLE: EPATCH_COMMON_OPTS
319# @DESCRIPTION:
320# Common options to pass to `patch`. You probably should never need to
321# change these. If you do, please discuss it with base-system first to
322# be sure.
323# @CODE
324# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
325# --no-backup-if-mismatch - do not leave .orig files behind
326# -E - automatically remove empty files
327# @CODE
328EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329# @VARIABLE: EPATCH_EXCLUDE
330# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 331# List of patches not to apply. Note this is only file names,
95# and not the full path .. 332# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 333EPATCH_EXCLUDE=""
334# @VARIABLE: EPATCH_SINGLE_MSG
335# @DESCRIPTION:
97# Change the printed message for a single patch. 336# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 337EPATCH_SINGLE_MSG=""
99# Force applying bulk patches even if not following the style: 338# @VARIABLE: EPATCH_MULTI_MSG
100# 339# @DESCRIPTION:
101# ??_${ARCH}_foo.${EPATCH_SUFFIX} 340# Change the printed message for multiple patches.
102# 341EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
342# @VARIABLE: EPATCH_FORCE
343# @DESCRIPTION:
344# Only require patches to match EPATCH_SUFFIX rather than the extended
345# arch naming style.
103EPATCH_FORCE="no" 346EPATCH_FORCE="no"
347# @VARIABLE: EPATCH_USER_EXCLUDE
348# @DEFAULT_UNSET
349# @DESCRIPTION:
350# List of patches not to apply. Note this is only file names,
351# and not the full path. Globs accepted.
104 352
105# This function is for bulk patching, or in theory for just one 353# @FUNCTION: epatch
106# or two patches. 354# @USAGE: [options] [patches] [dirs of patches]
355# @DESCRIPTION:
356# epatch is designed to greatly simplify the application of patches. It can
357# process patch files directly, or directories of patches. The patches may be
358# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
359# the -p option as epatch will automatically attempt -p0 to -p5 until things
360# apply successfully.
107# 361#
108# It should work with .bz2, .gz, .zip and plain text patches. 362# If you do not specify any patches/dirs, then epatch will default to the
109# Currently all patches should be the same format. 363# directory specified by EPATCH_SOURCE.
110# 364#
111# You do not have to specify '-p' option to patch, as it will 365# Any options specified that start with a dash will be passed down to patch
112# try with -p0 to -p5 until it succeed, or fail at -p5. 366# for this specific invocation. As soon as an arg w/out a dash is found, then
367# arg processing stops.
113# 368#
114# Above EPATCH_* variables can be used to control various defaults, 369# When processing directories, epatch will apply all patches that match:
115# bug they should be left as is to ensure an ebuild can rely on 370# @CODE
116# them for. 371# if ${EPATCH_FORCE} != "yes"
117#
118# Patches are applied in current directory.
119#
120# Bulk Patches should preferibly have the form of:
121#
122# ??_${ARCH}_foo.${EPATCH_SUFFIX} 372# ??_${ARCH}_foo.${EPATCH_SUFFIX}
373# else
374# *.${EPATCH_SUFFIX}
375# @CODE
376# The leading ?? are typically numbers used to force consistent patch ordering.
377# The arch field is used to apply patches only for the host architecture with
378# the special value of "all" means apply for everyone. Note that using values
379# other than "all" is highly discouraged -- you should apply patches all the
380# time and let architecture details be detected at configure/compile time.
123# 381#
124# For example: 382# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383# for patches to apply.
125# 384#
126# 01_all_misc-fix.patch.bz2 385# Refer to the other EPATCH_xxx variables for more customization of behavior.
127# 02_sparc_another-fix.patch.bz2
128#
129# This ensures that there are a set order, and you can have ARCH
130# specific patches.
131#
132# If you however give an argument to epatch(), it will treat it as a
133# single patch that need to be applied if its a file. If on the other
134# hand its a directory, it will set EPATCH_SOURCE to this.
135#
136# <azarah@gentoo.org> (10 Nov 2002)
137#
138epatch() { 386epatch() {
139 local PIPE_CMD="" 387 _epatch_draw_line() {
140 local STDERR_TARGET="${T}/$$.out" 388 # create a line of same length as input string
141 local PATCH_TARGET="${T}/$$.patch" 389 [[ -z $1 ]] && set "$(printf "%65s" '')"
142 local PATCH_SUFFIX="" 390 echo "${1//?/=}"
391 }
392
393 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
394
395 # First process options. We localize the EPATCH_OPTS setting
396 # from above so that we can pass it on in the loop below with
397 # any additional values the user has specified.
398 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399 while [[ $# -gt 0 ]] ; do
400 case $1 in
401 -*) EPATCH_OPTS+=( "$1" ) ;;
402 *) break ;;
403 esac
404 shift
405 done
406
407 # Let the rest of the code process one user arg at a time --
408 # each arg may expand into multiple patches, and each arg may
409 # need to start off with the default global EPATCH_xxx values
410 if [[ $# -gt 1 ]] ; then
411 local m
412 for m in "$@" ; do
413 epatch "${m}"
414 done
415 return 0
416 fi
417
143 local SINGLE_PATCH="no" 418 local SINGLE_PATCH="no"
144 local x="" 419 # no args means process ${EPATCH_SOURCE}
420 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
145 421
146 if [ "$#" -gt 1 ] 422 if [[ -f $1 ]] ; then
147 then
148 eerror "Invalid arguments to epatch()"
149 die "Invalid arguments to epatch()"
150 fi
151
152 if [ -n "$1" -a -f "$1" ]
153 then
154 SINGLE_PATCH="yes" 423 SINGLE_PATCH="yes"
155 424 set -- "$1"
156 local EPATCH_SOURCE="$1" 425 # Use the suffix from the single patch (localize it); the code
426 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 427 local EPATCH_SUFFIX=$1
158 428
159 elif [ -n "$1" -a -d "$1" ] 429 elif [[ -d $1 ]] ; then
160 then 430 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 431 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 432
433 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
434 # Re-use EPATCH_SOURCE as a search dir
435 epatch "${EPATCH_SOURCE}/$1"
436 return $?
437
438 else
439 # sanity check ... if it isn't a dir or file, wtf man ?
440 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
441 echo
442 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
443 eerror
444 eerror " ${EPATCH_SOURCE}"
445 eerror " ( ${EPATCH_SOURCE##*/} )"
446 echo
447 die "Cannot find \$EPATCH_SOURCE!"
448 fi
449
450 # Now that we know we're actually going to apply something, merge
451 # all of the patch options back in to a single variable for below.
452 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
453
454 local PIPE_CMD
455 case ${EPATCH_SUFFIX##*\.} in
456 xz) PIPE_CMD="xz -dc" ;;
457 lzma) PIPE_CMD="lzma -dc" ;;
458 bz2) PIPE_CMD="bzip2 -dc" ;;
459 gz|Z|z) PIPE_CMD="gzip -dc" ;;
460 ZIP|zip) PIPE_CMD="unzip -p" ;;
461 *) ;;
462 esac
463
464 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
465
466 local x
467 for x in "$@" ; do
468 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
469 # didn't match anything, ignore continue on
470 [[ ! -f ${x} ]] && continue
471
472 local patchname=${x##*/}
473
474 # Apply single patches, or forced sets of patches, or
475 # patches with ARCH dependant names.
476 # ???_arch_foo.patch
477 # Else, skip this input altogether
478 local a=${patchname#*_} # strip the ???_
479 a=${a%%_*} # strip the _foo.patch
480 if ! [[ ${SINGLE_PATCH} == "yes" || \
481 ${EPATCH_FORCE} == "yes" || \
482 ${a} == all || \
483 ${a} == ${ARCH} ]]
163 then 484 then
164 local EPATCH_SOURCE="$1/*" 485 continue
486 fi
487
488 # Let people filter things dynamically
489 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
490 # let people use globs in the exclude
491 eshopts_push -o noglob
492
493 local ex
494 for ex in ${EPATCH_EXCLUDE} ; do
495 if [[ ${patchname} == ${ex} ]] ; then
496 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
497 eshopts_pop
498 continue 2
499 fi
500 done
501
502 for ex in ${EPATCH_USER_EXCLUDE} ; do
503 if [[ ${patchname} == ${ex} ]] ; then
504 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
505 eshopts_pop
506 continue 2
507 fi
508 done
509
510 eshopts_pop
511 fi
512
513 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
514 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
515 einfo "${EPATCH_SINGLE_MSG}"
516 else
517 einfo "Applying ${patchname} ..."
518 fi
165 else 519 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 520 einfo " ${patchname} ..."
521 fi
522
523 # most of the time, there will only be one run per unique name,
524 # but if there are more, make sure we get unique log filenames
525 local STDERR_TARGET="${T}/${patchname}.out"
526 if [[ -e ${STDERR_TARGET} ]] ; then
527 STDERR_TARGET="${T}/${patchname}-$$.out"
528 fi
529
530 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
531
532 # Decompress the patch if need be
533 local count=0
534 local PATCH_TARGET
535 if [[ -n ${PIPE_CMD} ]] ; then
536 PATCH_TARGET="${T}/$$.patch"
537 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
538
539 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
540 echo
541 eerror "Could not extract patch!"
542 #die "Could not extract patch!"
543 count=5
544 break
167 fi 545 fi
546 else
547 PATCH_TARGET=${x}
548 fi
549
550 # Check for absolute paths in patches. If sandbox is disabled,
551 # people could (accidently) patch files in the root filesystem.
552 # Or trigger other unpleasantries #237667. So disallow -p0 on
553 # such patches.
554 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
555 if [[ -n ${abs_paths} ]] ; then
556 count=1
557 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
558 fi
559 # Similar reason, but with relative paths.
560 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
561 if [[ -n ${rel_paths} ]] ; then
562 echo
563 eerror "Rejected Patch: ${patchname} !"
564 eerror " ( ${PATCH_TARGET} )"
565 eerror
566 eerror "Your patch uses relative paths '../':"
567 eerror "${rel_paths}"
568 echo
569 die "you need to fix the relative paths in patch"
570 fi
571
572 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
573 local patch_cmd
574 # Handle aliased patch command #404447 #461568
575 local patch="patch"
576 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
577 while [[ ${count} -lt 5 ]] ; do
578 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
579
580 # Generate some useful debug info ...
581 (
582 _epatch_draw_line "***** ${patchname} *****"
583 echo
584 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
585 echo
586 _epatch_draw_line "***** ${patchname} *****"
587 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
588 ret=$?
589 echo
590 echo "patch program exited with status ${ret}"
591 exit ${ret}
592 ) >> "${STDERR_TARGET}"
593
594 if [ $? -eq 0 ] ; then
595 (
596 _epatch_draw_line "***** ${patchname} *****"
597 echo
598 echo "ACTUALLY APPLYING ${patchname} ..."
599 echo
600 _epatch_draw_line "***** ${patchname} *****"
601 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
602 ret=$?
603 echo
604 echo "patch program exited with status ${ret}"
605 exit ${ret}
606 ) >> "${STDERR_TARGET}"
607
608 if [ $? -ne 0 ] ; then
609 echo
610 eerror "A dry-run of patch command succeeded, but actually"
611 eerror "applying the patch failed!"
612 #die "Real world sux compared to the dreamworld!"
613 count=5
614 fi
615 break
616 fi
617
618 : $(( count++ ))
619 done
620
621 # if we had to decompress the patch, delete the temp one
622 if [[ -n ${PIPE_CMD} ]] ; then
623 rm -f "${PATCH_TARGET}"
624 fi
625
626 if [[ ${count} -ge 5 ]] ; then
627 echo
628 eerror "Failed Patch: ${patchname} !"
629 eerror " ( ${PATCH_TARGET} )"
630 eerror
631 eerror "Include in your bugreport the contents of:"
632 eerror
633 eerror " ${STDERR_TARGET}"
634 echo
635 die "Failed Patch: ${patchname}!"
636 fi
637
638 # if everything worked, delete the full debug patch log
639 rm -f "${STDERR_TARGET}"
640
641 # then log away the exact stuff for people to review later
642 cat <<-EOF >> "${T}/epatch.log"
643 PATCH: ${x}
644 CMD: ${patch_cmd}
645 PWD: ${PWD}
646
647 EOF
648 eend 0
649 done
650
651 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
652 : # everything worked
653}
654
655# @FUNCTION: epatch_user
656# @USAGE:
657# @DESCRIPTION:
658# Applies user-provided patches to the source tree. The patches are
659# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
660# of these three directories to exist will be the one to use, ignoring
661# any more general directories which might exist as well. They must end
662# in ".patch" to be applied.
663#
664# User patches are intended for quick testing of patches without ebuild
665# modifications, as well as for permanent customizations a user might
666# desire. Obviously, there can be no official support for arbitrarily
667# patched ebuilds. So whenever a build log in a bug report mentions that
668# user patches were applied, the user should be asked to reproduce the
669# problem without these.
670#
671# Not all ebuilds do call this function, so placing patches in the
672# stated directory might or might not work, depending on the package and
673# the eclasses it inherits and uses. It is safe to call the function
674# repeatedly, so it is always possible to add a call at the ebuild
675# level. The first call is the time when the patches will be
676# applied.
677#
678# Ideally, this function should be called after gentoo-specific patches
679# have been applied, so that their code can be modified as well, but
680# before calls to e.g. eautoreconf, as the user patches might affect
681# autotool input files as well.
682epatch_user() {
683 [[ $# -ne 0 ]] && die "epatch_user takes no options"
684
685 # Allow multiple calls to this function; ignore all but the first
686 local applied="${T}/epatch_user.log"
687 [[ -e ${applied} ]] && return 2
688
689 # don't clobber any EPATCH vars that the parent might want
690 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
691 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
692 EPATCH_SOURCE=${base}/${CTARGET}/${check}
693 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
694 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
695 if [[ -d ${EPATCH_SOURCE} ]] ; then
696 EPATCH_SOURCE=${EPATCH_SOURCE} \
697 EPATCH_SUFFIX="patch" \
698 EPATCH_FORCE="yes" \
699 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
700 epatch
701 echo "${EPATCH_SOURCE}" > "${applied}"
702 return 0
703 fi
704 done
705 echo "none" > "${applied}"
706 return 1
707}
708
709# @FUNCTION: emktemp
710# @USAGE: [temp dir]
711# @DESCRIPTION:
712# Cheap replacement for when debianutils (and thus mktemp)
713# does not exist on the users system.
714emktemp() {
715 local exe="touch"
716 [[ $1 == -d ]] && exe="mkdir" && shift
717 local topdir=$1
718
719 if [[ -z ${topdir} ]] ; then
720 [[ -z ${T} ]] \
721 && topdir="/tmp" \
722 || topdir=${T}
723 fi
724
725 if ! type -P mktemp > /dev/null ; then
726 # system lacks `mktemp` so we have to fake it
727 local tmp=/
728 while [[ -e ${tmp} ]] ; do
729 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
730 done
731 ${exe} "${tmp}" || ${exe} -p "${tmp}"
732 echo "${tmp}"
168 else 733 else
169 if [ ! -d ${EPATCH_SOURCE} ] 734 # the args here will give slightly wierd names on BSD,
170 then 735 # but should produce a usable file on all userlands
171 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 736 if [[ ${exe} == "touch" ]] ; then
172 then 737 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
173 EPATCH_SOURCE="$1" 738 else
739 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
740 fi
741 fi
742}
743
744# @FUNCTION: edos2unix
745# @USAGE: <file> [more files ...]
746# @DESCRIPTION:
747# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
748# to remove all of these text utilities from DEPEND variables because this
749# is a script based solution. Just give it a list of files to convert and
750# they will all be changed from the DOS CRLF format to the UNIX LF format.
751edos2unix() {
752 [[ $# -eq 0 ]] && return 0
753 sed -i 's/\r$//' -- "$@" || die
754}
755
756# @FUNCTION: make_desktop_entry
757# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
758# @DESCRIPTION:
759# Make a .desktop file.
760#
761# @CODE
762# binary: what command does the app run with ?
763# name: the name that will show up in the menu
764# icon: the icon to use in the menu entry
765# this can be relative (to /usr/share/pixmaps) or
766# a full path to an icon
767# type: what kind of application is this?
768# for categories:
769# http://standards.freedesktop.org/menu-spec/latest/apa.html
770# if unset, function tries to guess from package's category
771# fields: extra fields to append to the desktop file; a printf string
772# @CODE
773make_desktop_entry() {
774 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
775
776 local exec=${1}
777 local name=${2:-${PN}}
778 local icon=${3:-${PN}}
779 local type=${4}
780 local fields=${5}
781
782 if [[ -z ${type} ]] ; then
783 local catmaj=${CATEGORY%%-*}
784 local catmin=${CATEGORY##*-}
785 case ${catmaj} in
786 app)
787 case ${catmin} in
788 accessibility) type="Utility;Accessibility";;
789 admin) type=System;;
790 antivirus) type=System;;
791 arch) type="Utility;Archiving";;
792 backup) type="Utility;Archiving";;
793 cdr) type="AudioVideo;DiscBurning";;
794 dicts) type="Office;Dictionary";;
795 doc) type=Documentation;;
796 editors) type="Utility;TextEditor";;
797 emacs) type="Development;TextEditor";;
798 emulation) type="System;Emulator";;
799 laptop) type="Settings;HardwareSettings";;
800 office) type=Office;;
801 pda) type="Office;PDA";;
802 vim) type="Development;TextEditor";;
803 xemacs) type="Development;TextEditor";;
804 esac
805 ;;
806
807 dev)
808 type="Development"
809 ;;
810
811 games)
812 case ${catmin} in
813 action|fps) type=ActionGame;;
814 arcade) type=ArcadeGame;;
815 board) type=BoardGame;;
816 emulation) type=Emulator;;
817 kids) type=KidsGame;;
818 puzzle) type=LogicGame;;
819 roguelike) type=RolePlaying;;
820 rpg) type=RolePlaying;;
821 simulation) type=Simulation;;
822 sports) type=SportsGame;;
823 strategy) type=StrategyGame;;
824 esac
825 type="Game;${type}"
826 ;;
827
828 gnome)
829 type="Gnome;GTK"
830 ;;
831
832 kde)
833 type="KDE;Qt"
834 ;;
835
836 mail)
837 type="Network;Email"
838 ;;
839
840 media)
841 case ${catmin} in
842 gfx)
843 type=Graphics
844 ;;
845 *)
846 case ${catmin} in
847 radio) type=Tuner;;
848 sound) type=Audio;;
849 tv) type=TV;;
850 video) type=Video;;
851 esac
852 type="AudioVideo;${type}"
853 ;;
854 esac
855 ;;
856
857 net)
858 case ${catmin} in
859 dialup) type=Dialup;;
860 ftp) type=FileTransfer;;
861 im) type=InstantMessaging;;
862 irc) type=IRCClient;;
863 mail) type=Email;;
864 news) type=News;;
865 nntp) type=News;;
866 p2p) type=FileTransfer;;
867 voip) type=Telephony;;
868 esac
869 type="Network;${type}"
870 ;;
871
872 sci)
873 case ${catmin} in
874 astro*) type=Astronomy;;
875 bio*) type=Biology;;
876 calc*) type=Calculator;;
877 chem*) type=Chemistry;;
878 elec*) type=Electronics;;
879 geo*) type=Geology;;
880 math*) type=Math;;
881 physics) type=Physics;;
882 visual*) type=DataVisualization;;
883 esac
884 type="Education;Science;${type}"
885 ;;
886
887 sys)
888 type="System"
889 ;;
890
891 www)
892 case ${catmin} in
893 client) type=WebBrowser;;
894 esac
895 type="Network;${type}"
896 ;;
897
898 *)
899 type=
900 ;;
901 esac
902 fi
903 if [ "${SLOT}" == "0" ] ; then
904 local desktop_name="${PN}"
905 else
906 local desktop_name="${PN}-${SLOT}"
907 fi
908 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
909 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
910
911 # Don't append another ";" when a valid category value is provided.
912 type=${type%;}${type:+;}
913
914 eshopts_push -s extglob
915 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
916 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
917 ewarn "allowed in .desktop files if the value is not an absolute path."
918 icon=${icon%.@(xpm|png|svg)}
919 fi
920 eshopts_pop
921
922 cat <<-EOF > "${desktop}"
923 [Desktop Entry]
924 Name=${name}
925 Type=Application
926 Comment=${DESCRIPTION}
927 Exec=${exec}
928 TryExec=${exec%% *}
929 Icon=${icon}
930 Categories=${type}
931 EOF
932
933 if [[ ${fields:-=} != *=* ]] ; then
934 # 5th arg used to be value to Path=
935 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
936 fields="Path=${fields}"
937 fi
938 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
939
940 (
941 # wrap the env here so that the 'insinto' call
942 # doesn't corrupt the env of the caller
943 insinto /usr/share/applications
944 doins "${desktop}"
945 ) || die "installing desktop file failed"
946}
947
948# @FUNCTION: validate_desktop_entries
949# @USAGE: [directories]
950# @MAINTAINER:
951# Carsten Lohrke <carlo@gentoo.org>
952# @DESCRIPTION:
953# Validate desktop entries using desktop-file-utils
954validate_desktop_entries() {
955 if [[ -x /usr/bin/desktop-file-validate ]] ; then
956 einfo "Checking desktop entry validity"
957 local directories=""
958 for d in /usr/share/applications $@ ; do
959 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
960 done
961 if [[ -n ${directories} ]] ; then
962 for FILE in $(find ${directories} -name "*\.desktop" \
963 -not -path '*.hidden*' | sort -u 2>/dev/null)
964 do
965 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
966 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
967 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
968 done
969 fi
970 echo ""
971 else
972 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
973 fi
974}
975
976# @FUNCTION: make_session_desktop
977# @USAGE: <title> <command> [command args...]
978# @DESCRIPTION:
979# Make a GDM/KDM Session file. The title is the file to execute to start the
980# Window Manager. The command is the name of the Window Manager.
981#
982# You can set the name of the file via the ${wm} variable.
983make_session_desktop() {
984 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
985 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
986
987 local title=$1
988 local command=$2
989 local desktop=${T}/${wm:-${PN}}.desktop
990 shift 2
991
992 cat <<-EOF > "${desktop}"
993 [Desktop Entry]
994 Name=${title}
995 Comment=This session logs you into ${title}
996 Exec=${command} $*
997 TryExec=${command}
998 Type=XSession
999 EOF
1000
1001 (
1002 # wrap the env here so that the 'insinto' call
1003 # doesn't corrupt the env of the caller
1004 insinto /usr/share/xsessions
1005 doins "${desktop}"
1006 )
1007}
1008
1009# @FUNCTION: domenu
1010# @USAGE: <menus>
1011# @DESCRIPTION:
1012# Install the list of .desktop menu files into the appropriate directory
1013# (/usr/share/applications).
1014domenu() {
1015 (
1016 # wrap the env here so that the 'insinto' call
1017 # doesn't corrupt the env of the caller
1018 local i j ret=0
1019 insinto /usr/share/applications
1020 for i in "$@" ; do
1021 if [[ -f ${i} ]] ; then
1022 doins "${i}"
1023 ((ret+=$?))
1024 elif [[ -d ${i} ]] ; then
1025 for j in "${i}"/*.desktop ; do
1026 doins "${j}"
1027 ((ret+=$?))
1028 done
1029 else
1030 ((++ret))
1031 fi
1032 done
1033 exit ${ret}
1034 )
1035}
1036
1037# @FUNCTION: newmenu
1038# @USAGE: <menu> <newname>
1039# @DESCRIPTION:
1040# Like all other new* functions, install the specified menu as newname.
1041newmenu() {
1042 (
1043 # wrap the env here so that the 'insinto' call
1044 # doesn't corrupt the env of the caller
1045 insinto /usr/share/applications
1046 newins "$@"
1047 )
1048}
1049
1050# @FUNCTION: _iconins
1051# @INTERNAL
1052# @DESCRIPTION:
1053# function for use in doicon and newicon
1054_iconins() {
1055 (
1056 # wrap the env here so that the 'insinto' call
1057 # doesn't corrupt the env of the caller
1058 local funcname=$1; shift
1059 local size dir
1060 local context=apps
1061 local theme=hicolor
1062
1063 while [[ $# -gt 0 ]] ; do
1064 case $1 in
1065 -s|--size)
1066 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1067 size=${2%%x*}
1068 else
1069 size=${2}
174 fi 1070 fi
175 1071 case ${size} in
176 echo 1072 16|22|24|32|36|48|64|72|96|128|192|256)
177 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 1073 size=${size}x${size};;
178 eerror 1074 scalable)
179 eerror " ${EPATCH_SOURCE}"
180 echo
181 die "Cannot find \$EPATCH_SOURCE!"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi
186
187 case ${EPATCH_SUFFIX##*\.} in
188 bz2)
189 PIPE_CMD="bzip2 -dc"
190 PATCH_SUFFIX="bz2"
191 ;; 1075 ;;
192 gz|Z|z) 1076 *)
193 PIPE_CMD="gzip -dc" 1077 eerror "${size} is an unsupported icon size!"
194 PATCH_SUFFIX="gz" 1078 exit 1;;
195 ;; 1079 esac
196 ZIP|zip) 1080 shift 2;;
197 PIPE_CMD="unzip -p" 1081 -t|--theme)
198 PATCH_SUFFIX="zip" 1082 theme=${2}
199 ;; 1083 shift 2;;
1084 -c|--context)
1085 context=${2}
1086 shift 2;;
200 *) 1087 *)
201 PIPE_CMD="cat" 1088 if [[ -z ${size} ]] ; then
202 PATCH_SUFFIX="patch" 1089 insinto /usr/share/pixmaps
203 ;; 1090 else
204 esac 1091 insinto /usr/share/icons/${theme}/${size}/${context}
205
206 if [ "${SINGLE_PATCH}" = "no" ]
207 then
208 einfo "Applying various patches (bugfixes/updates)..."
209 fi
210 for x in ${EPATCH_SOURCE}
211 do
212 # New ARCH dependant patch naming scheme...
213 #
214 # ???_arch_foo.patch
215 #
216 if [ -f ${x} ] && \
217 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
218 [ "${EPATCH_FORCE}" = "yes" ])
219 then
220 local count=0
221 local popts="${EPATCH_OPTS}"
222
223 if [ -n "${EPATCH_EXCLUDE}" ]
224 then
225 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
226 then
227 continue
228 fi
229 fi 1092 fi
230 1093
231 if [ "${SINGLE_PATCH}" = "yes" ] 1094 if [[ ${funcname} == doicon ]] ; then
232 then 1095 if [[ -f $1 ]] ; then
233 if [ -n "${EPATCH_SINGLE_MSG}" ] 1096 doins "${1}"
234 then 1097 elif [[ -d $1 ]] ; then
235 einfo "${EPATCH_SINGLE_MSG}" 1098 shopt -s nullglob
1099 doins "${1}"/*.{png,svg}
1100 shopt -u nullglob
236 else 1101 else
237 einfo "Applying ${x##*/}..." 1102 eerror "${1} is not a valid file/directory!"
1103 exit 1
238 fi 1104 fi
239 else 1105 else
240 einfo " ${x##*/}..." 1106 break
241 fi 1107 fi
1108 shift 1;;
1109 esac
1110 done
1111 if [[ ${funcname} == newicon ]] ; then
1112 newins "$@"
1113 fi
1114 ) || die
1115}
242 1116
243 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1117# @FUNCTION: doicon
244 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1118# @USAGE: [options] <icons>
1119# @DESCRIPTION:
1120# Install icon into the icon directory /usr/share/icons or into
1121# /usr/share/pixmaps if "--size" is not set.
1122# This is useful in conjunction with creating desktop/menu files.
1123#
1124# @CODE
1125# options:
1126# -s, --size
1127# !!! must specify to install into /usr/share/icons/... !!!
1128# size of the icon, like 48 or 48x48
1129# supported icon sizes are:
1130# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1131# -c, --context
1132# defaults to "apps"
1133# -t, --theme
1134# defaults to "hicolor"
1135#
1136# icons: list of icons
1137#
1138# example 1: doicon foobar.png fuqbar.svg suckbar.png
1139# results in: insinto /usr/share/pixmaps
1140# doins foobar.png fuqbar.svg suckbar.png
1141#
1142# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1143# results in: insinto /usr/share/icons/hicolor/48x48/apps
1144# doins foobar.png fuqbar.png blobbar.png
1145# @CODE
1146doicon() {
1147 _iconins ${FUNCNAME} "$@"
1148}
245 1149
246 # Allow for prefix to differ ... im lazy, so shoot me :/ 1150# @FUNCTION: newicon
247 while [ "${count}" -lt 5 ] 1151# @USAGE: [options] <icon> <newname>
248 do 1152# @DESCRIPTION:
249 # Generate some useful debug info ... 1153# Like doicon, install the specified icon as newname.
250 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1154#
251 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1155# @CODE
1156# example 1: newicon foobar.png NEWNAME.png
1157# results in: insinto /usr/share/pixmaps
1158# newins foobar.png NEWNAME.png
1159#
1160# example 2: newicon -s 48 foobar.png NEWNAME.png
1161# results in: insinto /usr/share/icons/hicolor/48x48/apps
1162# newins foobar.png NEWNAME.png
1163# @CODE
1164newicon() {
1165 _iconins ${FUNCNAME} "$@"
1166}
252 1167
253 if [ "${PATCH_SUFFIX}" != "patch" ] 1168# @FUNCTION: strip-linguas
254 then 1169# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
255 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1170# @DESCRIPTION:
256 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1171# Make sure that LINGUAS only contains languages that
1172# a package can support. The first form allows you to
1173# specify a list of LINGUAS. The -i builds a list of po
1174# files found in all the directories and uses the
1175# intersection of the lists. The -u builds a list of po
1176# files found in all the directories and uses the union
1177# of the lists.
1178strip-linguas() {
1179 local ls newls nols
1180 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1181 local op=$1; shift
1182 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1183 local d f
1184 for d in "$@" ; do
1185 if [[ ${op} == "-u" ]] ; then
1186 newls=${ls}
1187 else
1188 newls=""
1189 fi
1190 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1191 if [[ ${op} == "-i" ]] ; then
1192 has ${f} ${ls} && newls="${newls} ${f}"
257 else 1193 else
258 PATCH_TARGET="${x}" 1194 has ${f} ${ls} || newls="${newls} ${f}"
259 fi 1195 fi
260
261 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
262 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
263
264 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
265 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
270 then
271 echo
272 eerror "Could not extract patch!"
273 #die "Could not extract patch!"
274 count=5
275 break
276 fi
277 fi
278
279 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
280 then
281 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
282 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
283 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
284 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
285 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
286
287 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
288
289 if [ "$?" -ne 0 ]
290 then
291 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
292 echo
293 eerror "A dry-run of patch command succeeded, but actually"
294 eerror "applying the patch failed!"
295 #die "Real world sux compared to the dreamworld!"
296 count=5
297 fi
298
299 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
300
301 break
302 fi
303
304 count=$((count + 1))
305 done 1196 done
306 1197 ls=${newls}
307 if [ "${PATCH_SUFFIX}" != "patch" ] 1198 done
308 then 1199 else
309 rm -f ${PATCH_TARGET} 1200 ls="$@"
310 fi 1201 fi
311 1202
312 if [ "${count}" -eq 5 ] 1203 nols=""
313 then 1204 newls=""
314 echo 1205 for f in ${LINGUAS} ; do
315 eerror "Failed Patch: ${x##*/}!" 1206 if has ${f} ${ls} ; then
316 eerror 1207 newls="${newls} ${f}"
317 eerror "Include in your bugreport the contents of:" 1208 else
318 eerror 1209 nols="${nols} ${f}"
319 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
320 echo
321 die "Failed Patch: ${x##*/}!"
322 fi
323
324 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
325
326 eend 0
327 fi 1210 fi
328 done 1211 done
329 if [ "${SINGLE_PATCH}" = "no" ] 1212 [[ -n ${nols} ]] \
330 then 1213 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
331 einfo "Done with patching" 1214 export LINGUAS=${newls:1}
332 fi
333} 1215}
334 1216
335# This function return true if we are using the NPTL pthreads 1217# @FUNCTION: preserve_old_lib
336# implementation. 1218# @USAGE: <libs to preserve> [more libs]
337# 1219# @DESCRIPTION:
338# <azarah@gentoo.org> (06 March 2003) 1220# These functions are useful when a lib in your package changes ABI SONAME.
339# 1221# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
340 1222# would break packages that link against it. Most people get around this
341have_NPTL() { 1223# by using the portage SLOT mechanism, but that is not always a relevant
342 1224# solution, so instead you can call this from pkg_preinst. See also the
343 cat > ${T}/test-nptl.c <<-"END" 1225# preserve_old_lib_notify function.
344 #define _XOPEN_SOURCE 1226preserve_old_lib() {
345 #include <unistd.h> 1227 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
346 #include <stdio.h> 1228 eerror "preserve_old_lib() must be called from pkg_preinst() only"
347 1229 die "Invalid preserve_old_lib() usage"
348 int main()
349 {
350 char buf[255];
351 char *str = buf;
352
353 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
354 if (NULL != str) {
355 printf("%s\n", str);
356 if (NULL != strstr(str, "NPTL"))
357 return 0;
358 }
359
360 return 1;
361 }
362 END
363
364 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
365 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
366 then
367 echo "yes"
368 einfon "Checking what PTHREADS implementation we have ... "
369 if ${T}/nptl
370 then
371 return 0
372 else
373 return 1
374 fi 1230 fi
375 else 1231 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
376 echo "no"
377 fi
378 1232
379 return 1 1233 # let portage worry about it
380} 1234 has preserve-libs ${FEATURES} && return 0
381 1235
382# This function check how many cpu's are present, and then set 1236 local lib dir
383# -j in MAKEOPTS accordingly. 1237 for lib in "$@" ; do
384# 1238 [[ -e ${ROOT}/${lib} ]] || continue
385# Thanks to nall <nall@gentoo.org> for this. 1239 dir=${lib%/*}
386# 1240 dodir ${dir} || die "dodir ${dir} failed"
387get_number_of_jobs() { 1241 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
388 local jobs=0 1242 touch "${D}"/${lib}
1243 done
1244}
389 1245
390 if [ ! -r /proc/cpuinfo ] 1246# @FUNCTION: preserve_old_lib_notify
391 then 1247# @USAGE: <libs to notify> [more libs]
392 return 1 1248# @DESCRIPTION:
393 fi 1249# Spit helpful messages about the libraries preserved by preserve_old_lib.
394 1250preserve_old_lib_notify() {
395 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565. 1251 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
396 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ] 1252 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
397 then 1253 die "Invalid preserve_old_lib_notify() usage"
398 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
399 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
400 ADMINPARAM="${ADMINPARAM/-j}"
401 fi
402
403 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
404
405 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
406 "${ARCH}" = "arm" -o "${ARCH}" = "mips" ]
407 then
408 # these archs will always have "[Pp]rocessor"
409 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
410
411 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
412 then
413 # sparc always has "ncpus active"
414 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
415
416 elif [ "${ARCH}" = "alpha" ]
417 then
418 # alpha has "cpus active", but only when compiled with SMP
419 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
420 then
421 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
422 else
423 jobs=2
424 fi 1254 fi
425 1255
426 elif [ "${ARCH}" = "ppc" ] 1256 # let portage worry about it
427 then 1257 has preserve-libs ${FEATURES} && return 0
428 # ppc has "processor", but only when compiled with SMP 1258
429 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ] 1259 local lib notice=0
430 then 1260 for lib in "$@" ; do
431 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))" 1261 [[ -e ${ROOT}/${lib} ]] || continue
432 else 1262 if [[ ${notice} -eq 0 ]] ; then
433 jobs=2 1263 notice=1
434 fi 1264 ewarn "Old versions of installed libraries were detected on your system."
435 else 1265 ewarn "In order to avoid breaking packages that depend on these old libs,"
436 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))" 1266 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
437 die "Unknown ARCH -- ${ARCH}!" 1267 ewarn "in order to remove these old dependencies. If you do not have this"
1268 ewarn "helper program, simply emerge the 'gentoolkit' package."
1269 ewarn
438 fi 1270 fi
1271 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1272 done
1273}
439 1274
440 # Make sure the number is valid ... 1275# @FUNCTION: built_with_use
441 if [ "${jobs}" -lt 1 ] 1276# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
442 then 1277# @DESCRIPTION:
443 jobs=1 1278#
444 fi 1279# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
445 1280#
446 if [ -n "${ADMINPARAM}" ] 1281# A temporary hack until portage properly supports DEPENDing on USE
447 then 1282# flags being enabled in packages. This will check to see if the specified
448 if [ "${jobs}" -gt "${ADMINPARAM}" ] 1283# DEPEND atom was built with the specified list of USE flags. The
449 then 1284# --missing option controls the behavior if called on a package that does
450 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..." 1285# not actually support the defined USE flags (aka listed in IUSE).
451 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}" 1286# The default is to abort (call die). The -a and -o flags control
452 else 1287# the requirements of the USE flags. They correspond to "and" and "or"
453 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..." 1288# logic. So the -a flag means all listed USE flags must be enabled
454 export MAKEOPTS="${MAKEOPTS} -j${jobs}" 1289# while the -o flag means at least one of the listed IUSE flags must be
1290# enabled. The --hidden option is really for internal use only as it
1291# means the USE flag we're checking is hidden expanded, so it won't be found
1292# in IUSE like normal USE flags.
1293#
1294# Remember that this function isn't terribly intelligent so order of optional
1295# flags matter.
1296built_with_use() {
1297 local hidden="no"
1298 if [[ $1 == "--hidden" ]] ; then
1299 hidden="yes"
1300 shift
455 fi 1301 fi
456 fi
457}
458 1302
459# Simplify/standardize adding users to the system 1303 local missing_action="die"
460# vapier@gentoo.org 1304 if [[ $1 == "--missing" ]] ; then
461# 1305 missing_action=$2
462# enewuser(username, uid, shell, homedir, groups, extra options) 1306 shift ; shift
463# 1307 case ${missing_action} in
464# Default values if you do not specify any: 1308 true|false|die) ;;
465# username: REQUIRED ! 1309 *) die "unknown action '${missing_action}'";;
466# uid: next available (see useradd(8)) 1310 esac
467# note: pass -1 to get default behavior
468# shell: /bin/false
469# homedir: /dev/null
470# groups: none
471# extra: comment of 'added by portage for ${PN}'
472enewuser() {
473 # get the username
474 local euser="$1"; shift
475 if [ -z "${euser}" ] ; then
476 eerror "No username specified !"
477 die "Cannot call enewuser without a username"
478 fi
479 einfo "Adding user '${euser}' to your system ..."
480
481 # setup a file for testing usernames/groups
482 local tmpfile="`mktemp -p ${T}`"
483 touch ${tmpfile}
484 chown ${euser} ${tmpfile} >& /dev/null
485 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
486
487 # see if user already exists
488 if [ "${euser}" == "${realuser}" ] ; then
489 einfo "${euser} already exists on your system :)"
490 return 0
491 fi
492
493 # options to pass to useradd
494 local opts=""
495
496 # handle uid
497 local euid="$1"; shift
498 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] ; then
499 if [ ${euid} -gt 0 ] ; then
500 opts="${opts} -u ${euid}"
501 else
502 eerror "Userid given but is not greater than 0 !"
503 die "${euid} is not a valid UID"
504 fi 1311 fi
505 else
506 euid="next available"
507 fi
508 einfo " - Userid: ${euid}"
509 1312
510 # handle shell 1313 local opt=$1
511 local eshell="$1"; shift 1314 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
512 if [ ! -z "${eshell}" ] ; then 1315
513 if [ ! -e ${eshell} ] ; then 1316 local PKG=$(best_version $1)
514 eerror "A shell was specified but it does not exist !" 1317 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
515 die "${eshell} does not exist" 1318 shift
1319
1320 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1321 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1322
1323 # if the IUSE file doesn't exist, the read will error out, we need to handle
1324 # this gracefully
1325 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1326 case ${missing_action} in
1327 true) return 0;;
1328 false) return 1;;
1329 die) die "Unable to determine what USE flags $PKG was built with";;
1330 esac
516 fi 1331 fi
517 else
518 eshell=/bin/false
519 fi
520 einfo " - Shell: ${eshell}"
521 opts="${opts} -s ${eshell}"
522 1332
523 # handle homedir 1333 if [[ ${hidden} == "no" ]] ; then
524 local ehome="$1"; shift 1334 local IUSE_BUILT=( $(<"${IUSEFILE}") )
525 if [ -z "${ehome}" ] ; then 1335 # Don't check USE_EXPAND #147237
526 ehome=/dev/null 1336 local expand
527 fi 1337 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
528 einfo " - Home: ${ehome}" 1338 if [[ $1 == ${expand}_* ]] ; then
529 opts="${opts} -d ${ehome}" 1339 expand=""
530 1340 break
531 # handle groups
532 local egroups="$1"; shift
533 if [ ! -z "${egroups}" ] ; then
534 local realgroup
535 local oldifs="${IFS}"
536 export IFS=","
537 for g in ${egroups} ; do
538 chgrp ${g} ${tmpfile} >& /dev/null
539 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
540 if [ "${g}" != "${realgroup}" ] ; then
541 eerror "You must add ${g} to the system first"
542 die "${g} is not a valid GID"
543 fi 1341 fi
544 done 1342 done
545 export IFS="${oldifs}" 1343 if [[ -n ${expand} ]] ; then
546 opts="${opts} -g ${egroups}" 1344 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1345 case ${missing_action} in
1346 true) return 0;;
1347 false) return 1;;
1348 die) die "$PKG does not actually support the $1 USE flag!";;
1349 esac
1350 fi
1351 fi
1352 fi
1353
1354 local USE_BUILT=$(<${USEFILE})
1355 while [[ $# -gt 0 ]] ; do
1356 if [[ ${opt} = "-o" ]] ; then
1357 has $1 ${USE_BUILT} && return 0
1358 else
1359 has $1 ${USE_BUILT} || return 1
1360 fi
1361 shift
1362 done
1363 [[ ${opt} = "-a" ]]
1364}
1365
1366# @FUNCTION: epunt_cxx
1367# @USAGE: [dir to scan]
1368# @DESCRIPTION:
1369# Many configure scripts wrongly bail when a C++ compiler could not be
1370# detected. If dir is not specified, then it defaults to ${S}.
1371#
1372# http://bugs.gentoo.org/73450
1373epunt_cxx() {
1374 local dir=$1
1375 [[ -z ${dir} ]] && dir=${S}
1376 ebegin "Removing useless C++ checks"
1377 local f p any_found
1378 while IFS= read -r -d '' f; do
1379 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1380 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1381 any_found=1
1382 break
1383 fi
1384 done
1385 done < <(find "${dir}" -name configure -print0)
1386
1387 if [[ -z ${any_found} ]]; then
1388 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1389 fi
1390 eend 0
1391}
1392
1393# @FUNCTION: make_wrapper
1394# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1395# @DESCRIPTION:
1396# Create a shell wrapper script named wrapper in installpath
1397# (defaults to the bindir) to execute target (default of wrapper) by
1398# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1399# libpaths followed by optionally changing directory to chdir.
1400make_wrapper() {
1401 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1402 local tmpwrapper=$(emktemp)
1403
1404 (
1405 echo '#!/bin/sh'
1406 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1407 if [[ -n ${libdir} ]] ; then
1408 cat <<-EOF
1409 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1410 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1411 else
1412 export LD_LIBRARY_PATH="${libdir}"
1413 fi
1414 EOF
1415 fi
1416 # We don't want to quote ${bin} so that people can pass complex
1417 # things as ${bin} ... "./someprog --args"
1418 printf 'exec %s "$@"\n' "${bin}"
1419 ) > "${tmpwrapper}"
1420 chmod go+rx "${tmpwrapper}"
1421
1422 if [[ -n ${path} ]] ; then
1423 (
1424 exeinto "${path}"
1425 newexe "${tmpwrapper}" "${wrapper}"
1426 ) || die
547 else 1427 else
548 egroups="(none)" 1428 newbin "${tmpwrapper}" "${wrapper}" || die
1429 fi
1430}
1431
1432# @FUNCTION: path_exists
1433# @USAGE: [-a|-o] <paths>
1434# @DESCRIPTION:
1435# Check if the specified paths exist. Works for all types of paths
1436# (files/dirs/etc...). The -a and -o flags control the requirements
1437# of the paths. They correspond to "and" and "or" logic. So the -a
1438# flag means all the paths must exist while the -o flag means at least
1439# one of the paths must exist. The default behavior is "and". If no
1440# paths are specified, then the return value is "false".
1441path_exists() {
1442 local opt=$1
1443 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1444
1445 # no paths -> return false
1446 # same behavior as: [[ -e "" ]]
1447 [[ $# -eq 0 ]] && return 1
1448
1449 local p r=0
1450 for p in "$@" ; do
1451 [[ -e ${p} ]]
1452 : $(( r += $? ))
1453 done
1454
1455 case ${opt} in
1456 -a) return $(( r != 0 )) ;;
1457 -o) return $(( r == $# )) ;;
1458 esac
1459}
1460
1461# @FUNCTION: in_iuse
1462# @USAGE: <flag>
1463# @DESCRIPTION:
1464# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1465# as necessary.
1466#
1467# Note that this function should not be used in the global scope.
1468in_iuse() {
1469 debug-print-function ${FUNCNAME} "${@}"
1470 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1471
1472 local flag=${1}
1473 local liuse=( ${IUSE} )
1474
1475 has "${flag}" "${liuse[@]#[+-]}"
1476}
1477
1478# @FUNCTION: use_if_iuse
1479# @USAGE: <flag>
1480# @DESCRIPTION:
1481# Return true if the given flag is in USE and IUSE.
1482#
1483# Note that this function should not be used in the global scope.
1484use_if_iuse() {
1485 in_iuse $1 || return 1
1486 use $1
1487}
1488
1489# @FUNCTION: usex
1490# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1491# @DESCRIPTION:
1492# Proxy to declare usex for package managers or EAPIs that do not provide it
1493# and use the package manager implementation when available (i.e. EAPI >= 5).
1494# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1495# otherwise echo [false output][false suffix] (defaults to "no").
1496if has "${EAPI:-0}" 0 1 2 3 4; then
1497 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1498fi
1499
1500# @FUNCTION: prune_libtool_files
1501# @USAGE: [--all|--modules]
1502# @DESCRIPTION:
1503# Locate unnecessary libtool files (.la) and libtool static archives
1504# (.a) and remove them from installation image.
1505#
1506# By default, .la files are removed whenever the static linkage can
1507# either be performed using pkg-config or doesn't introduce additional
1508# flags.
1509#
1510# If '--modules' argument is passed, .la files for modules (plugins) are
1511# removed as well. This is usually useful when the package installs
1512# plugins and the plugin loader does not use .la files.
1513#
1514# If '--all' argument is passed, all .la files are removed without
1515# performing any heuristic on them. You shouldn't ever use that,
1516# and instead report a bug in the algorithm instead.
1517#
1518# The .a files are only removed whenever corresponding .la files state
1519# that they should not be linked to, i.e. whenever these files
1520# correspond to plugins.
1521#
1522# Note: if your package installs both static libraries and .pc files
1523# which use variable substitution for -l flags, you need to add
1524# pkg-config to your DEPEND.
1525prune_libtool_files() {
1526 debug-print-function ${FUNCNAME} "$@"
1527
1528 local removing_all removing_modules opt
1529 for opt; do
1530 case "${opt}" in
1531 --all)
1532 removing_all=1
1533 removing_modules=1
1534 ;;
1535 --modules)
1536 removing_modules=1
1537 ;;
1538 *)
1539 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1540 esac
1541 done
1542
1543 local f
1544 local queue=()
1545 while IFS= read -r -d '' f; do # for all .la files
1546 local archivefile=${f/%.la/.a}
1547
1548 # The following check is done by libtool itself.
1549 # It helps us avoid removing random files which match '*.la',
1550 # see bug #468380.
1551 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1552 continue
549 fi 1553 fi
550 einfo " - Groups: ${egroups}"
551 1554
552 # handle extra and add the user 1555 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
553 local eextra="$@" 1556 local reason pkgconfig_scanned
554 local oldsandbox="${oldsandbox}" 1557 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
555 export SANDBOX_ON="0" 1558
556 if [ -z "${eextra}" ] ; then 1559 if [[ ${snotlink} == yes ]]; then
557 useradd ${opts} ${euser} \ 1560
558 -c "added by portage for ${PN}" \ 1561 # Remove static libs we're not supposed to link against.
559 || die "enewuser failed" 1562 if [[ -f ${archivefile} ]]; then
560 else 1563 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
561 einfo " - Extra: ${eextra}" 1564 queue+=( "${archivefile}" )
562 useradd ${opts} ${euser} ${eextra} \
563 || die "enewuser failed"
564 fi 1565 fi
565 export SANDBOX_ON="${oldsandbox}"
566 1566
567 if [ ! -e ${ehome} ] && [ ! -e ${D}/${ehome} ] ; then 1567 # The .la file may be used by a module loader, so avoid removing it
568 einfo " - Creating ${ehome} in ${D}" 1568 # unless explicitly requested.
569 dodir ${ehome} 1569 if [[ ${removing_modules} ]]; then
570 fperms ${euser} ${ehome} 1570 reason='module'
571 fi 1571 fi
572}
573 1572
574# Simplify/standardize adding groups to the system
575# vapier@gentoo.org
576#
577# enewgroup(group, gid)
578#
579# Default values if you do not specify any:
580# groupname: REQUIRED !
581# gid: next available (see groupadd(8))
582# extra: none
583enewgroup() {
584 # get the group
585 local egroup="$1"; shift
586 if [ -z "${egroup}" ] ; then
587 eerror "No group specified !"
588 die "Cannot call enewgroup without a group"
589 fi
590 einfo "Adding group '${egroup}' to your system ..."
591
592 # setup a file for testing groupname
593 local tmpfile="`mktemp -p ${T}`"
594 touch ${tmpfile}
595 chgrp ${egroup} ${tmpfile} >& /dev/null
596 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
597
598 # see if group already exists
599 if [ "${egroup}" == "${realgroup}" ] ; then
600 einfo "${egroup} already exists on your system :)"
601 return 0
602 fi
603
604 # options to pass to useradd
605 local opts=""
606
607 # handle gid
608 local egid="$1"; shift
609 if [ ! -z "${egid}" ] ; then
610 if [ ${egid} -gt 0 ] ; then
611 opts="${opts} -g ${egid}"
612 else 1573 else
613 eerror "Groupid given but is not greater than 0 !"
614 die "${egid} is not a valid GID"
615 fi
616 else
617 egid="next available"
618 fi
619 einfo " - Groupid: ${egid}"
620 1574
621 # handle extra 1575 # Remove .la files when:
622 local eextra="$@" 1576 # - user explicitly wants us to remove all .la files,
623 opts="${opts} ${eextra}" 1577 # - respective static archive doesn't exist,
1578 # - they are covered by a .pc file already,
1579 # - they don't provide any new information (no libs & no flags).
624 1580
625 # add the group 1581 if [[ ${removing_all} ]]; then
626 local oldsandbox="${oldsandbox}" 1582 reason='requested'
627 export SANDBOX_ON="0" 1583 elif [[ ! -f ${archivefile} ]]; then
628 groupadd ${opts} ${egroup} || die "enewgroup failed" 1584 reason='no static archive'
629 export SANDBOX_ON="${oldsandbox}" 1585 elif [[ ! $(sed -nre \
630} 1586 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
631 1587 "${f}") ]]; then
632# Simple script to replace 'dos2unix' binaries 1588 reason='no libs & flags'
633# vapier@gentoo.org
634#
635# edos2unix(file, <more files>...)
636edos2unix() {
637 for f in $@ ; do
638 cp ${f} ${T}/edos2unix
639 sed 's/\r$//' ${T}/edos2unix > ${f}
640 done
641}
642
643# new convenience patch wrapper function to eventually replace epatch(),
644# $PATCHES, $PATCHES1, src_unpack:patch, src_unpack:autopatch and
645# /usr/bin/patch
646# Features:
647# - bulk patch handling similar to epatch()'s
648# - automatic patch level detection like epatch()'s
649# - automatic patch uncompression like epatch()'s
650# - doesn't have the --dry-run overhead of epatch() - inspects patchfiles
651# manually instead
652# - once I decide it's production-ready, it'll be called from base_src_unpack
653# to handle $PATCHES to avoid defining src_unpack just to use xpatch
654
655# accepts zero or more parameters specifying patchfiles and/or patchdirs
656
657# known issues:
658# - only supports unified style patches (does anyone _really_ use anything
659# else?)
660# - because it doesn't use --dry-run there is a risk of it failing
661# to find the files to patch, ie detect the patchlevel, properly. It doesn't use
662# any of the backup heuristics that patch employs to discover a filename.
663# however, this isn't dangerous because if it works for the developer who's
664# writing the ebuild, it'll always work for the users, and if it doesn't,
665# then we'll fix it :-)
666# - no support as yet for patches applying outside $S (and not directly in $WORKDIR).
667xpatch() {
668
669 debug-print-function $FUNCNAME $*
670
671 local list=""
672 local list2=""
673 declare -i plevel
674
675 # parse patch sources
676 for x in $*; do
677 debug-print "$FUNCNAME: parsing parameter $x"
678 if [ -f "$x" ]; then
679 list="$list $x"
680 elif [ -d "$x" ]; then
681 # handles patchdirs like epatch() for now: no recursion.
682 # patches are sorted by filename, so with an xy_foo naming scheme you'll get the right order.
683 # only patches with _$ARCH_ or _all_ in their filenames are applied.
684 for file in `ls -A $x`; do
685 debug-print "$FUNCNAME: parsing in subdir: file $file"
686 if [ -f "$x/$file" ] && [ "${file}" != "${file/_all_}" -o "${file}" != "${file/_$ARCH_}" ]; then
687 list2="$list2 $x/$file"
688 fi
689 done
690 list="`echo $list2 | sort` $list"
691 else 1589 else
692 die "Couldn't find $x" 1590 if [[ ! ${pkgconfig_scanned} ]]; then
1591 # Create a list of all .pc-covered libs.
1592 local pc_libs=()
1593 if [[ ! ${removing_all} ]]; then
1594 local pc
1595 local tf=${T}/prune-lt-files.pc
1596 local pkgconf=$(tc-getPKG_CONFIG)
1597
1598 while IFS= read -r -d '' pc; do # for all .pc files
1599 local arg libs
1600
1601 # Use pkg-config if available (and works),
1602 # fallback to sed.
1603 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1604 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1605 libs=$(${pkgconf} --libs "${tf}")
1606 else
1607 libs=$(sed -ne 's/^Libs://p' "${pc}")
1608 fi
1609
1610 for arg in ${libs}; do
1611 if [[ ${arg} == -l* ]]; then
1612 if [[ ${arg} == '*$*' ]]; then
1613 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1614 eqawarn "(arg: ${arg})"
1615 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1616 fi
1617
1618 pc_libs+=( lib${arg#-l}.la )
1619 fi
1620 done
1621 done < <(find "${D}" -type f -name '*.pc' -print0)
1622
1623 rm -f "${tf}"
1624 fi
1625
1626 pkgconfig_scanned=1
1627 fi # pkgconfig_scanned
1628
1629 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1630 fi # removal due to .pc
1631
1632 fi # shouldnotlink==no
1633
1634 if [[ ${reason} ]]; then
1635 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1636 queue+=( "${f}" )
1637 fi
1638 done < <(find "${D}" -xtype f -name '*.la' -print0)
1639
1640 if [[ ${queue[@]} ]]; then
1641 rm -f "${queue[@]}"
693 fi 1642 fi
694 done
695
696 debug-print "$FUNCNAME: final list of patches: $list"
697
698 for x in $list; do
699 debug-print "$FUNCNAME: processing $x"
700 # deal with compressed files. /usr/bin/file is in the system profile, or should be.
701 case "`/usr/bin/file -b $x`" in
702 *gzip*) patchfile="${T}/current.patch"; ungzip -c "$x" > "${patchfile}";;
703 *bzip2*) patchfile="${T}/current.patch"; bunzip2 -c "$x" > "${patchfile}";;
704 *text*) patchfile="$x";;
705 *) die "Could not determine filetype of patch $x";;
706 esac
707 debug-print "$FUNCNAME: patchfile=$patchfile"
708
709 # determine patchlevel. supports p0 and higher with either $S or $WORKDIR as base.
710 target="`/bin/grep -m 1 '^+++ ' $patchfile`"
711 debug-print "$FUNCNAME: raw target=$target"
712 # strip target down to the path/filename, remove leading +++
713 target="${target/+++ }"; target="${target%% *}"
714 # duplicate slashes are discarded by patch wrt the patchlevel. therefore we need
715 # to discard them as well to calculate the correct patchlevel.
716 target="${target//\/\//\/}"
717 debug-print "$FUNCNAME: stripped target=$target"
718
719 # look for target
720 for basedir in "$S" "$WORKDIR" "${PWD}"; do
721 debug-print "$FUNCNAME: looking in basedir=$basedir"
722 cd "$basedir"
723
724 # try stripping leading directories
725 target2="$target"
726 plevel=0
727 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
728 while [ ! -f "$target2" ]; do
729 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
730 plevel=plevel+1
731 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
732 [ "$target2" == "${target2/\/}" ] && break
733 done
734 test -f "$target2" && break
735
736 # try stripping filename - needed to support patches creating new files
737 target2="${target%/*}"
738 plevel=0
739 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
740 while [ ! -d "$target2" ]; do
741 target2="${target2#*/}" # removes piece of target2 upto the first occurence of /
742 plevel=plevel+1
743 debug-print "$FUNCNAME: trying target2=$target2, plevel=$plevel"
744 [ "$target2" == "${target2/\/}" ] && break
745 done
746 test -d "$target2" && break
747
748 done
749
750 test -f "${basedir}/${target2}" || test -d "${basedir}/${target2}" || die "Could not determine patchlevel for $x"
751 debug-print "$FUNCNAME: determined plevel=$plevel"
752 # do the patching
753 ebegin "Applying patch ${x##*/}..."
754 /usr/bin/patch -p$plevel < "$patchfile" > /dev/null || die "Failed to apply patch $x"
755 eend $?
756
757 done
758
759} 1643}
1644
1645check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1646
1647fi

Legend:
Removed from v.1.35  
changed lines
  Added in v.1.423

  ViewVC Help
Powered by ViewVC 1.1.20